package info.bukova.isspst.filters;

import static info.bukova.isspst.StringUtils.nullStr;
import info.bukova.isspst.data.Requirement;

import org.hamcrest.Description;
import org.hamcrest.Factory;
import org.hamcrest.Matcher;
import org.hamcrest.TypeSafeMatcher;

public class RequirementFilter implements Filter<Requirement>
{

	private Requirement condition;

	public RequirementFilter(Requirement cond)
	{
		this.condition = cond;
	}

	private static class RequirementMatcher extends TypeSafeMatcher<Requirement>
	{

		private Requirement condition;

		public RequirementMatcher(Requirement cond)
		{
			this.condition = cond;
		}

		@Override
		public void describeTo(Description desc)
		{
			desc.appendText("requirement matches");
		}

		@Override
		public boolean matchesSafely(Requirement item)
		{
			return nullStr(item.getNumser()).toLowerCase().contains(nullStr(condition.getNumser()).toLowerCase())
					&& item.getReqDate().equals(condition.getReqDate())
					&& item.getDeliveryDate().equals(condition.getDeliveryDate())
					&& nullStr(item.getDescription()).toLowerCase().contains(nullStr(condition.getDescription()).toLowerCase());
		}

		@Factory
		public static Matcher<Requirement> matchBuilding(Requirement building)
		{
			return new RequirementMatcher(building);
		}
	}

	@Override
	public RequirementMatcher matcher()
	{
		return new RequirementMatcher(condition);
	}

	@Override
	public String queryString()
	{
		return "";
	}

}
